<!doctype html>
<html>
<head>
    <title>Tor&#39;s Bug Smash Fund: Progress So Far | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Tor&#39;s Bug Smash Fund: Progress So Far | Tor Project">
    <meta property="og:description" content="So far, we’ve marked 77 tickets with BugSmashFund. As of today, 56 of those tickets have been closed, and 21 of them are still in progress. With this reserve, we’ve been able to fix bugs and complete necessary maintenance on core tor, bridgedb, Snowflake, and Metrics, as well as complete the Tor Browser ESR 68 migration.">
    <meta property="og:image" content="https://blog.torproject.org/tor-bug-smash-fund-progress/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/tor-bug-smash-fund-progress/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Tor&#39;s Bug Smash Fund: Progress So Far
      </h1>
    <p class="meta">by al | January 21, 2020</p>
    <picture>
      
      <img class="lead" src="lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>At the beginning of August 2019, we asked you to help us build <a href="https://blog.torproject.org/tors-bug-smash-fund-help-tor-smash-all-bugs">our very first Bug Smash Fund</a>. This fund will ensure that the Tor Project has a healthy reserve earmarked for maintenance work and smashing the bugs necessary to keep Tor Browser, the Tor network, and the <a href="https://blog.torproject.org/strength-numbers-entire-ecosystem-relies-tor">many tools that rely on Tor</a> strong, safe, and running smoothly. Together we raised $86,081.</p>
<p>We want to share an update on some of the work the Bug Smash Fund has made possible.</p>
<p>So far, we’ve marked 77 tickets with <a href="https://trac.torproject.org/projects/tor/query?status=accepted&amp;status=assigned&amp;status=closed&amp;status=merge_ready&amp;status=needs_information&amp;status=needs_review&amp;status=needs_revision&amp;status=new&amp;status=reopened&amp;keywords=~BugSmashFund&amp;group=component&amp;col=id&amp;col=summary&amp;col=status&amp;col=type&amp;col=priority&amp;col=milestone&amp;col=component&amp;order=status">BugSmashFund</a>. As of today, 56 of those tickets have been closed, and 21 of them are still in progress. With this reserve, we’ve been able to fix bugs and complete necessary maintenance on core tor, bridgedb, Snowflake, and Metrics, as well as complete the Tor Browser ESR 68 migration. Roughly half of the Bug Smash Fund remains available for allocation, and we will continue to tag relevant maintenance work and bug fixing tickets that will be covered with this reserve. Thanks for supporting this work!</p>
<p>Below is a full list of the tickets we’ve closed so far.</p>
<h2>Tor Browser – ESR Migration</h2>
<p>Tor Browser is built on the Firefox Extended Series Release. When a new ESR is available, we migrate Tor Browser (both desktop and Android), which requires significant attention from the Tor Browser team. The Bug Smash Fund covered the following tickets associated with the ESR 68 migration completed in late 2019.</p>
<ul>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/21549" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">21549  Investigate wasm for linkability/fingerprintability/disk avoidance issues</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/26345" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">26345  Disable tracking protection UI in FF67-esr</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/28822" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">28822  re-implement desktop onboarding for ESR 68</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/30304" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">30304  Browser locale can be obtained via DTD strings</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/30429" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">30429  Rebase Tor Browser patches for Firefox ESR 68</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/30460" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">30460  Update TOPL Project to Use Android Toolchain (Firefox 68)</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/30463" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">30463  Make sure telemetry reporting is disabled in Tor Browser 9</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/30504" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">30504  Investigate if New Identity works properly after moving to ESR 68</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/30662" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">30662  Make sure about:newtab is blank</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/30665" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">30665  Get Firefox 68 ESR Working with latest android toolchain</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/30846" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">30846  Audit activity-stream for network requests</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31065" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31065  Set network.proxy.allow_hijacking_localhost to true</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31192" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31192  TBA - Support x86_64 target</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31286" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31286  Include bridge configuration into about:preferences</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31308" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31308  Sync mozconfig files used in tor-browser over to tor-browser-build for esr68</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31448" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31448  gold and lld break linking 32bit Linux bundles we need to resort to bfd</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31450" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31450  Still use GCC for 64bit Linux debug builds after switch to 68 ESR</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31457" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31457  disable per-installation profiles</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31607" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31607  App menu items stop working</span></span></span></span></span></span></span></span></a></p>
</li>
</ul>
<h2>Anti-Censorship</h2>
<p>Bridges are Tor relays that help people circumvent censorship against the Tor network. For several reasons, people may want to ask for a bridge via email, and for these circumstances, we have the <a href="mailto:bridge@torproject.org">bridge@torproject.org</a> distribution method. When somebody emails <a href="mailto:bridges@torproject.org">bridges@torproject.org</a> from a riseup or Gmail account, the account replies with a bridge. The Bug Smash Fund helped fix bugs related to this mechanism.</p>
<p><a href="https://snowflake.torproject.org/">Snowflake</a> is a new system to defeat censorship. The Bug Smash Fund also helped us to work on a spec that will contribute to the process of collecting metrics on Snowflake.</p>
<ul>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/32105" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">32105  bridges@torproject.org don't respond</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31407" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31407  Create a broker spec for metrics collection</span></span></span></span></span></span></span></span></a></p>
</li>
</ul>
<h2>Core Tor</h2>
<p>The Bug Smash Fund has helped the Network team to fix many bugs—from circuit padding to onion services to documentation—as well as backport many previous bug fixes.</p>
<ul>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/25568" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">25568  hs: Lookup failure cache when introducing to an intro point</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/27992" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">27992  config DataDirectoryGroupReadable 1 is overridden if you set KeyDir == DataDir</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/30344" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">30344  conn_read_callback is called on connections that are marked for closed</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/30916" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">30916  assert in dimap_add_entry()</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31107" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31107  channel: channel_tls_handle_cell() CELL_VERSIONS code reached</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31111" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31111  Properly support two padding machines per circuit</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31189" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31189  potential docs update needed for GuardLifetime?</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31408" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31408  torrc : ClientOnionAuthDir after include directives breaks client to v2 services</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31466" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31466  Consider demoting ".exit is disabled" log message to info</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31570" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31570  INTERNAL ERROR: raw assertion failed (core dump) in termux</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31571" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31571  Add the tor version and a newline to raw_assert()</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31615" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31615  Reorder the early subsystems based on their dependencies</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31657" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31657  Rephrase "missing descriptors" notice log to be less confusing</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31687" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31687  FreeBSD compilation warns with Tor 0.4.1.5</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31696" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31696  Assertion failure in map-anon.c:218</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31734" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31734  Add accessor functions for cb_buf, which enforce locking and unlocking</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31793" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31793  Bug: tor_addr_is_internal() called from src/feature/dirauth/process_descs.c:447 with a non-IP address of type 0</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31807" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31807  Update outdated documentation note for "bridge-distribution"</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31825" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31825  Use the full name of optional modules, rather than an abbreviation</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31837" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31837  Make test_rebind.py more robust</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31841" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31841  test addr/parse takes a long time on master on some machines</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31884" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31884  Define ExecuteBash in the Appveyor error block</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31897" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31897  util/map_anon_nofork test fails on SunOS</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/31939" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31939  log spam: Bug: buffers_tls.c:73: buf_read_from_tls: Non-fatal assertion !(buf-&gt;datalen &gt;= INT_MAX - at_most) failed.</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/32058" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">32058  mainloop: make periodic events restartable</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/32060" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">32060  CID 1454761: wrong type passed to unlock_cb_buf()?</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/32108" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">32108  tor can overrun its accountingmax if it enters soft hibernation first</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/32124" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">32124  Interpret --disable-module-dirauth=no correctly</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/32191" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">32191  when cross-compiling, lzma and zstd will be detected on build system</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/32196" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">32196  cmux: Implement unit tests</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/32338" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">32338  Warn about more relative file paths when validating options</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/32352" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">32352  Stop adding a space when dumping an empty config value</span></span></span></span></span></span></span></span></a></p>
</li>
<li style="list-style-type:disc">
<p><a href="https://trac.torproject.org/projects/tor/ticket/32463" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">32463  TypeError in practracker "includes.py" script</span></span></span></span></span></span></span></span></a></p>
</li>
</ul>
<h2>Metrics</h2>
<p>This fund made it possible for the Metrics team to improve tooling, as well as fix a bug in the Tor network data collecting service, <a href="https://metrics.torproject.org/collector.html">CollecTor</a>.</p>
<ul>
<li style="list-style-type:disc"><a href="https://trac.torproject.org/projects/tor/ticket/31398" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31398  Add all metrics master branches to GitLab's CI</span></span></span></span></span></span></span></span></a></li>
<li style="list-style-type:disc"><a href="https://trac.torproject.org/projects/tor/ticket/31558" style="text-decoration:none"><span style="font-size:11pt; font-variant:normal; white-space:pre-wrap"><span style="font-family:Arial"><span style="color:#1155cc"><span style="font-weight:400"><span style="font-style:normal"><span style="text-decoration:underline"><span style="-webkit-text-decoration-skip:none"><span style="text-decoration-skip-ink:none">31558  Process bridge pool assignments again</span></span></span></span></span></span></span></span></a></li>
</ul>
<p>Thank you to everybody who made a contribution to the Bug Smash Fund. This work is critical in helping us to provide safer tools for millions of people around the world exercising their human rights to privacy and freedom online.</p>
<p>If you’d like to make a contribution to the Bug Smash Fund, you can do so by making a gift at <a href="https://donate.torproject.org">donate.torproject.org</a>: just add “Bug Smash Fund” into the comment field, and we’ll make sure it’s directed to the right place.</p>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/applications">
          applications
        </a>
      </li><li>
        <a href="../category/circumvention">
          circumvention
        </a>
      </li><li>
        <a href="../category/fundraising">
          fundraising
        </a>
      </li><li>
        <a href="../category/metrics">
          metrics
        </a>
      </li><li>
        <a href="../category/network">
          network
        </a>
      </li><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-286507"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-286507" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Al Brandon (not verified)</span> said:</p>
      <p class="date-time">January 21, 2020</p>
    </div>
    <a href="#comment-286507">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-286507" class="permalink" rel="bookmark">Fantastic news!</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Fantastic news!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-286510"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-286510" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">January 22, 2020</p>
    </div>
    <a href="#comment-286510">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-286510" class="permalink" rel="bookmark">I like this, thanks! Keep…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I like this, thanks! Keep sharing on your progress whenever you make one!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-286519"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-286519" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">January 23, 2020</p>
    </div>
    <a href="#comment-286519">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-286519" class="permalink" rel="bookmark">Thank you very much…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Thank you very much.</p>
<p>Espeically thank you for the Anti-Censorship efforts<br />
hope snowflake works well,Since the Novel Coronavirus situation I won't be surprised that CCP would probably block  and choke internet access.Nothing is sure,but the only sure thing is that situation inside the GFW will only get worse</p>
<p>Nonetheless,best wishes for tor people and anyone who atleast tries to do the real works</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-286530"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-286530" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">January 24, 2020</p>
    </div>
    <a href="#comment-286530">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-286530" class="permalink" rel="bookmark">Big Big Bug torbirdy broken …</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Big Big Bug torbirdy broken - Need Big Big Bug fix</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-286541"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-286541" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">January 24, 2020</p>
    </div>
    <a href="#comment-286541">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-286541" class="permalink" rel="bookmark">Considering its topic of…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Considering its topic of privacy and network security, I thought you all would be interested in this video about VPNs by Louis Rossmann, a right-to-repair advocate. More and more Youtube "influencers" are shilling stuff all. the. time.</p>
<p>"The cost of shilling VPN companies is your reputation."<br />
<a href="https://www.youtube.com/watch?v=G1thc5DSHwA" rel="nofollow">https://www.youtube.com/watch?v=G1thc5DSHwA</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-286598"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-286598" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>RDM (not verified)</span> said:</p>
      <p class="date-time">January 30, 2020</p>
    </div>
    <a href="#comment-286598">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-286598" class="permalink" rel="bookmark">Excellent news, keep up the…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Excellent news, keep up the great work</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-286623"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-286623" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Franz Ritzbergher (not verified)</span> said:</p>
      <p class="date-time">February 02, 2020</p>
    </div>
    <a href="#comment-286623">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-286623" class="permalink" rel="bookmark">einfach spitze</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>einfach spitze</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
